<%@include file="/includeTags.jsp" %>

<style>
	.rich-stglpanel-marker {float: left}
	.emptyToggle {		
		border: 1px #ffffff; 
		background:#ffffff;
	}
</style>

<a4j:keepAlive beanName="scoringScaleController" />

<h:form id="scoringScaleForm">
<rich:panel id="scoringScaleOuterPanel">
	<c:if test="${empty scoringScaleController.scoringObject.scoringScale.scoringDimensions}">
		<htm:table id="noDimensionsFound" width="100%" border="1" cellpadding="0" cellspacing="0" style="align:left;height:30px;" bgcolor="#f5f0d2">
			<htm:tr>
				<htm:td>&nbsp;&nbsp;&nbsp;<h:outputText styleClass="score-scale-heading" value="No dimensions found. Please click 'Add a new dimension' to add new dimensions."/></htm:td>
			</htm:tr>
		</htm:table>
	</c:if>
	<c:if test="${not empty scoringScaleController.scoringObject.scoringScale.scoringDimensions}">
	
		<a4j:repeat value="#{scoringScaleController.scoringObject.scoringScale.scoringDimensions}" var="scoringDimension" rowKeyVar="dimensionIndex">
			<rich:simpleTogglePanel switchType="client" id="scoringScalePanel" >
				<f:facet name="header">
					<h:panelGrid id="panelHeading" columns="2" width="93%" columnClasses="score-scale-head-left,score-scale-head-right"
						cellpadding="0" cellspacing="0">
						
						<h:column id="dimensionName">
				    		<h:outputText value="#{scoringDimension.dimensionName}" styleClass="score-scale-heading"/>
				    	</h:column>    		
				    	<h:column id="deleteDimension">        			    				
				    		<h:graphicImage id="deleteDimensionImage" url="/resources/images/richfaces/grid/checkoutByOtherUser.GIF"/>
				    		<rich:spacer width="10" id="deleteDimensionSpace"/>
				    		<a4j:commandLink id="deleteDimensionLink" value="Delete this Dimension" styleClass="score-scale-heading" 
				    			onclick="Richfaces.showModalPanel('deleteDimensionWindow')">
				    			<a4j:actionparam name="dimensionName" value="#{scoringDimension.dimensionName}" 
										assignTo="#{scoringScaleController.dimensionName}" />
				    		</a4j:commandLink>    				
				    	</h:column>
					</h:panelGrid>
				</f:facet>
				<f:facet name="openMarker">
					<h:graphicImage id="openImage" url="/resources/images/wordExpand.gif"/>
				</f:facet>
				<f:facet name="closeMarker">
					<h:graphicImage id="closeImage" url="/resources/images/wordCollapse.gif"/>
				</f:facet>
				<h:panelGrid id="scoringScaleBody" style="width:97%;">
					<h:panelGrid id="scoringScalePanelGrid" columns="2" width="100%" border="1" 
						cellpadding="0" cellspacing="0" style="align:left;" bgcolor="#f5f0d2">
						
						<h:panelGrid columns="3" width="100%" border="0" cellpadding="0" cellspacing="0" columnClasses="score-scale-column1,score-scale-column2,score-scale-column1">
							<h:panelGrid id="nemricRangePanel" columns="1" columnClasses="score-scale-align-center,score-scale-align-center" width="100%">
								<h:outputText id="nemricRangeLabel" value="Numeric Range" styleClass="score-scale-heading"/>
									<h:column id="nemricRangeColumn">
									<h:selectOneMenu id="rangeFrom" value="#{scoringDimension.numericRangeFrom}">
										<f:selectItem itemLabel="0" itemValue="0"/>
										<f:selectItem itemLabel="1" itemValue="1"/>
										<f:selectItem itemLabel="2" itemValue="2"/>
										<f:selectItem itemLabel="3" itemValue="3"/>
										<f:selectItem itemLabel="4" itemValue="4"/>
									</h:selectOneMenu>
									&nbsp;&nbsp;
									<h:outputText id="toLabel" value="To" styleClass="score-scale-label"/>
									&nbsp;&nbsp;
									<h:selectOneMenu id="rangeTo" value="#{scoringDimension.numericRangeTo}">
										<f:selectItem itemLabel="1" itemValue="1"/>
										<f:selectItem itemLabel="2" itemValue="2"/>
										<f:selectItem itemLabel="3" itemValue="3"/>
										<f:selectItem itemLabel="4" itemValue="4"/>
									</h:selectOneMenu>				
								</h:column>
								<a4j:commandLink id="customRangeLabel" value="Custom Range"  styleClass="score-scale-label" ajaxSingle="true"
									onclick="showRichFacesPleaseWait();" oncomplete="hideRichFacesPleaseWait();Richfaces.showModalPanel('customRangeWindow');" reRender="customRangePanel">
									<a4j:actionparam name="dimensionName" value="#{scoringDimension.dimensionName}" assignTo="#{scoringScaleController.dimensionName}"/>																		
								</a4j:commandLink>  
							</h:panelGrid>
							<h:panelGrid columns="1" id="alphaValuesPanel" columnClasses="score-scale-align-center,score-scale-align-center" width="100%">
								<h:outputText id="alphaValuesLabel" value="Alpha Values" styleClass="score-scale-heading"/>
								<h:column id="alphaValuesColumn">
									<ibis-jsf:multiSelectCombo id="alphaValues#{dimensionIndex}" checkAllLabel="Check All Alpha Values" 
										data="#{scoringDimension.alphaValues}" action="#{scoringScaleController.setAlphaValues}">								
										<a4j:actionparam name="dimensionName" value="#{scoringDimension.dimensionName}"/>
									</ibis-jsf:multiSelectCombo>			
								</h:column>			
							</h:panelGrid>
							<h:panelGrid columns="1" id="updateAllPanel" columnClasses="score-scale-align-center" width="100%">
								<h:column id="updateAllColumn">		
									<%--Used document.getElementById('updateDimensionLink').click(); because other field 
										values (numeric to, from) need to accessed from controller. --%>							
									<a4j:commandButton value="Update Dimension"  	
										ajaxSingle="true" immediate="false"	onclick="showRichFacesPleaseWait();"				 
										oncomplete="document.getElementById('updateDimensionLink').click();" styleClass="rich-list-shuttle-button">
										<a4j:actionparam name="dimensionName" value="#{scoringDimension.dimensionName}" assignTo="#{scoringScaleController.dimensionName}"/>
									</a4j:commandButton>		
								</h:column>			
							</h:panelGrid>					
						</h:panelGrid>	
						<h:panelGrid columns="1" id="allowableDifferencePanel" columnClasses="score-scale-align-center,score-scale-align-center" width="100%">
							<h:outputText id="allowableDifferenceLabel" value="Allowable Difference" styleClass="score-scale-heading"/>
							<h:column id="allowableDifferenceColumn">
								<h:panelGrid width="100%" id="raterGrid" columns="2">
									<h:outputText id="raterLabel" value="Rater:" styleClass="score-scale-label"/>
									<h:column id="raterCoulum">
										<h:inputText id="rater" maxlength="2" size="2" value="#{scoringDimension.rater}"/>
										<h:outputText id="raterDot" value="." styleClass="score-scale-heading"/>
										<h:inputText id="raterDecimal" maxlength="4" size="4" value="#{scoringDimension.raterDecimal}"/>
									</h:column>
									<h:outputText id="automatedLabel" value="Automated:" styleClass="score-scale-label"/>
									<h:column id="automatedColumn">
										<h:inputText id="automated" maxlength="2" size="2" value="#{scoringDimension.automated}"/>
										<h:outputText id="automatedDot" value="." styleClass="score-scale-heading"/>
										<h:inputText id="automatedDecimal" maxlength="4" size="4" value="#{scoringDimension.automatedDecimal}"/>
									</h:column>
								</h:panelGrid>
							</h:column>			
						</h:panelGrid>	
					</h:panelGrid>
					
					<rich:spacer height="2"/>
					
					<htm:table width="100%" cellpadding="0" cellspacing="0" border="1">
						<htm:tr>
							<htm:td styleClass="score-scale-align-center">
								<h:outputText id="responseCodesLabel" value="Response Codes" styleClass="score-scale-heading"/>
							</htm:td>
							<htm:td styleClass="score-scale-align-center">
								<h:outputText id="scoreWeightsLabel" value="Score Weights" styleClass="score-scale-heading"/>
							</htm:td>
							<htm:td styleClass="score-scale-align-center">
								<h:outputText id="interpretiveScoreLabel" value="Interpretive Score (IS)" styleClass="score-scale-heading"/>
							</htm:td>
							<htm:td styleClass="score-scale-align-center">
								<h:outputText id="actionTypeLabel" value="Special Action Type Code" styleClass="score-scale-heading"/>
							</htm:td>
							<htm:td styleClass="score-scale-align-center">
								<h:outputText id="diagnosticReasonLabel" value="Diagnostic Reason Code" styleClass="score-scale-heading"/>
							</htm:td>
						</htm:tr>	
						<a4j:repeat value="#{scoringDimension.dimensions}" var="dimension" rowKeyVar="rowIndex">
							<htm:tr>
								<htm:td styleClass="score-scale-align-center">						
									<h:outputText id="responseCodeID" value="#{dimension.responseCode}" styleClass="score-scale-label"/>
								</htm:td>
								<htm:td styleClass="score-scale-align-center">
									<h:inputText id="scoringWeightsID" value="#{dimension.scoringWeights}" maxlength="4" size="4">
										<a4j:actionparam name="id" value="scoringWeightsID"/>
									</h:inputText>
								</htm:td>
								<htm:td styleClass="score-scale-align-center">
									<h:selectOneMenu id="interpretiveScoreID" value="#{dimension.interpretiveScore}">
										<f:selectItem itemLabel="0" itemValue="0"/>
										<f:selectItem itemLabel="1" itemValue="1"/>
										<f:selectItem itemLabel="2" itemValue="2"/>
										<f:selectItem itemLabel="3" itemValue="3"/>
										<f:selectItem itemLabel="4" itemValue="4"/>
										<f:selectItem itemLabel="5" itemValue="5"/>
										<f:selectItem itemLabel="6" itemValue="6"/>
										<f:selectItem itemLabel="7" itemValue="7"/>
										<f:selectItem itemLabel="8" itemValue="8"/>
										<f:selectItem itemLabel="9" itemValue="9"/>
									</h:selectOneMenu>
								</htm:td>
								<htm:td styleClass="score-scale-align-center">
									<h:selectOneMenu id="actionTypeCodeID" value="#{dimension.actionTypeCode}">
										<f:selectItems value="#{scoringScaleController.scoringObject.scoringScale.actionTypeCodes}"/>
									</h:selectOneMenu>
								</htm:td>
								<htm:td styleClass="score-scale-align-center">
									<ibis-jsf:multiSelectCombo id="reasonCodes#{dimensionIndex}#{rowIndex}" componentIndex="#{rowIndex}" 
										checkAllLabel="Check All Reason" data="#{dimension.reasonCodes}"  action="#{scoringScaleController.setReasonCodes}">
										<a4j:actionparam name="dimensionName" value="#{scoringDimension.dimensionName}"/>
										<a4j:actionparam name="dimensionRowID" value="#{rowIndex}"/>
									</ibis-jsf:multiSelectCombo>
								</htm:td>
							</htm:tr>
						</a4j:repeat>
					</htm:table>
				</h:panelGrid>	
				
			</rich:simpleTogglePanel>
		</a4j:repeat>
	</c:if>

	<htm:table width="97%">
		<htm:tr>
			<htm:td width="100%" align="right">
				<t:commandLink value="" id="updateDimensionLink" forceId="true" action="#{scoringScaleController.updateDimension}"/>	
				<t:commandLink value="" id="runSaveAndCloseScoringScale" forceId="true"/>
				<a4j:commandButton id="addNewDimension" value="Add a new dimension" ajaxSingle="true"
					onclick="showRichFacesPleaseWait();" oncomplete="hideRichFacesPleaseWait();Richfaces.showModalPanel('addNewDimensionWindow');" 
					styleClass="rich-list-shuttle-button">
				</a4j:commandButton>				
				<rich:spacer width="5"/>
				<h:commandButton id="saveAndCloseScoringScale" value="Save and Close" 	
					onclick="showRichFacesPleaseWait();" action="#{scoringScaleController.saveAndClose}" 					
					styleClass="rich-list-shuttle-button">
				</h:commandButton>
				<rich:spacer width="5"/>
				<h:commandButton id="saveScoringScale" value="Save" action="#{scoringScaleController.save}"
					onclick="showRichFacesPleaseWait();" styleClass="rich-list-shuttle-button">
				</h:commandButton>	
				<rich:spacer width="5"/>
				<h:commandButton id="cancelScoringScale" value="Cancel" type="button" styleClass="rich-list-shuttle-button" 
					onclick="return parent.objectCancel();" />
			</htm:td>
		</htm:tr>
	</htm:table>	
</rich:panel>
</h:form>
<a4j:jsFunction name="rerenderCustomRange" id="rerenderCustomRange" reRender="customRangePanel" 
	ajaxSingle="true" immediate="true" oncomplete="focusCurrentScore();">
	<a4j:actionparam name="index" value="index" noEscape="true" assignTo="#{scoringScaleController.numericRangeIndex}"/>
</a4j:jsFunction>	
	
<rich:modalPanel id="addNewDimensionWindow" resizeable="false" width="350" height="100" autosized="true" top="350">
	<f:facet name="header">
		<h:outputText value="Add a new dimension" />
	</f:facet>
	<f:facet name="controls">
		<h:panelGroup>
			<h:graphicImage value="/resources/images/richfaces/grid/close.png" id="addNewDimensionWindowClose" styleClass="hidelink" />
			<rich:componentControl for="addNewDimensionWindow" attachTo="addNewDimensionWindowClose" operation="hide" event="onclick" />
		</h:panelGroup>
	</f:facet>
	<a4j:outputPanel id="dimensionsPanel">
		<h:panelGrid columns="1" width="100%">
			<h:panelGrid columns="1" width="100%">
				<htm:table width="100%">
					<c:forEach items="${scoringScaleController.dimensions}" var="dimensionValue">
						<tr class="<c:if test="${dimensionValue.readOnly}">disabled-background</c:if>">
							<htm:td><input type="radio" id="dimensionNameRadio" name="dimensionNameRadio" value="<c:out value="${dimensionValue.label}"/>" <c:if test="${dimensionValue.checked}">checked</c:if> <c:if test="${dimensionValue.readOnly}">disabled</c:if>/></htm:td>
							<htm:td><c:out value="${dimensionValue.label}"/></htm:td>
						</tr>
					</c:forEach>					
				</htm:table>			
			</h:panelGrid>				
			<h:panelGrid columns="3" width="100%">
				<rich:spacer width="220"/>
				<a4j:commandButton value="Ok" onclick="showRichFacesPleaseWait();Richfaces.hideModalPanel('addNewDimensionWindow');"		
					action="#{scoringScaleController.addNewDimension}" reRender="scoringScaleOuterPanel, dimensionsPanel" ajaxSingle="true" oncomplete="hideRichFacesPleaseWait();checkMessage(false);"
					immediate="false" styleClass="rich-list-shuttle-button">
					<a4j:actionparam name="newDimensionName" value="getSelectedValue('dimensionNameRadio')" assignTo="#{scoringScaleController.dimensionName}" noEscape="true"/>
				</a4j:commandButton>
				<a4j:commandButton value="Cancel"
					onclick="Richfaces.hideModalPanel('addNewDimensionWindow')"
					styleClass="rich-list-shuttle-button">
				</a4j:commandButton>				
			</h:panelGrid>		
		</h:panelGrid>
	</a4j:outputPanel>
</rich:modalPanel>


<rich:modalPanel id="deleteDimensionWindow" resizeable="false" width="350" height="100" autosized="true" top="350">
	<f:facet name="header">
		<h:outputText value="Confirm delete dimension" />
	</f:facet>
	<f:facet name="controls">
		<h:panelGroup>
			<h:graphicImage value="/resources/images/richfaces/grid/close.png" id="deleteDimensionWindowClose" styleClass="hidelink" />
			<rich:componentControl for="deleteDimensionWindow" attachTo="deleteDimensionWindowClose" operation="hide" event="onclick" />
		</h:panelGroup>
	</f:facet>
	<a4j:outputPanel id="deleteDimensionsPanel">
			<h:panelGrid columns="1" width="100%">
				<h:panelGrid columns="1" width="100%">
					<h:outputText value="Deleting this scale Dimension cannot be reversed..." style="font-weight:bold;"/>
				</h:panelGrid>				
				<h:panelGrid columns="3" width="100%">
					<rich:spacer width="220"/>
					<a4j:commandButton id="deleteScoringScale" value="Ok" onclick="showRichFacesPleaseWait();Richfaces.hideModalPanel('deleteDimensionWindow')"		
						action="#{scoringScaleController.deleteDimension}" reRender="scoringScaleOuterPanel, dimensionsPanel" ajaxSingle="true"
						oncomplete="hideRichFacesPleaseWait();"
						immediate="true" styleClass="rich-list-shuttle-button">
					</a4j:commandButton>
					<a4j:commandButton value="Cancel"
						onclick="Richfaces.hideModalPanel('deleteDimensionWindow')"
						styleClass="rich-list-shuttle-button">
					</a4j:commandButton>				
				</h:panelGrid>		
			</h:panelGrid>
	</a4j:outputPanel>
</rich:modalPanel>


<rich:modalPanel id="customRangeWindow" resizeable="false" width="350" height="100" autosized="true" top="350">
	<f:facet name="header">
		<h:outputText value="Set Custom Numeric Range" />
	</f:facet>
	<f:facet name="controls">
		<h:panelGroup>
			<h:graphicImage value="/resources/images/richfaces/grid/close.png" id="customRangeWindowClose" styleClass="hidelink" />
			<rich:componentControl for="customRangeWindow" attachTo="customRangeWindowClose" operation="hide" event="onclick" />
		</h:panelGroup>
	</f:facet>
	<a4j:outputPanel id="customRangePanel">
			<h:panelGrid columns="1" width="100%">
				<htm:table width="100%" border="0" style="border-color:red;" cellpadding="0" cellspacing="0">
					<htm:tr>
						<htm:td width="50%" valign="top">			
							<c:if test="${empty scoringScaleController.customRange}">
								<htm:table width="100%">
									<htm:tr>
										<htm:td><h:outputText value="No scoring values found." styleClass="score-scale-heading"/></htm:td>
									</htm:tr>	
								</htm:table>
							</c:if>
							<c:if test="${not empty scoringScaleController.customRange}">
								<htm:div style="overflow:auto;height:110;">
									<htm:table width="100%" border="1" style="border-color: #BED6F8;" cellpadding="0" cellspacing="0">
										<c:if test="${not empty scoringScaleController.customRange}">
											<htm:tr>
												<htm:td colspan="2" align="center"> <h:outputText value="Scoring Value" styleClass="score-scale-heading"/> </htm:td>
											</htm:tr>						
											<c:forEach items="${scoringScaleController.customRange}" var="customRange" varStatus="rowIndex">
												<htm:tr>
													<htm:td><input type="radio" id="customRangeRadio" name="customRangeRadio" value="<c:out value="${customRange.label}"/>" onclick="rerenderCustomRange(<c:out value="${rowIndex.index}"/>)" <c:if test="${customRange.checked}">checked</c:if>/></htm:td>
													<htm:td>
														<c:if test="${customRange.checked}">
															<input type="text" name="customRangeTxt" id="customRangeTxt" size="5" value="<c:out value="${customRange.label}"/>"/>
														</c:if>
														<c:if test="${!customRange.checked}">										
															<c:out value="${customRange.label}"/>
														</c:if>																					
													</htm:td>
												</htm:tr>							
											</c:forEach>
										</c:if>
									</htm:table>
								</htm:div>
							</c:if>
						</htm:td>
						<htm:td width="10%">&nbsp;</htm:td>				
						<htm:td width="40%" valign="top" align="center">
							<htm:table width="100%" cellpadding="0" cellspacing="0">
								<htm:tr>
									<htm:td>
										<a4j:commandButton value="Add another row" 
											action="#{scoringScaleController.addCustomRange}" reRender="customRangePanel, scoringScaleOuterPanel" 
											ajaxSingle="true" immediate="true" onclick="showRichFacesPleaseWait();" oncomplete="hideRichFacesPleaseWait();checkMessage(false);focusCurrentScore();"
											styleClass="rich-list-shuttle-button" style="width:120px;text-align:left;">
											<a4j:actionparam name="index" value="getSelectedIndex('customRangeRadio')" noEscape="true" assignTo="#{scoringScaleController.numericRangeIndex}"/>							
										</a4j:commandButton>					
									</htm:td>
								</htm:tr>
								<htm:tr>
									<htm:td>
										<a4j:commandButton value="Delete selected row" 		
											action="#{scoringScaleController.deleteCustomRange}" reRender="customRangePanel, scoringScaleOuterPanel" 
												ajaxSingle="true" immediate="true" onclick="showRichFacesPleaseWait();" oncomplete="hideRichFacesPleaseWait();checkMessage(false);focusCurrentScore();"
												styleClass="rich-list-shuttle-button" style="width:120px;text-align:left;">	
											<a4j:actionparam name="index" value="getSelectedIndex('customRangeRadio')" noEscape="true" assignTo="#{scoringScaleController.numericRangeIndex}"/>
											<a4j:actionparam name="oldResponseCode" value="getSelectedValue('customRangeRadio')" noEscape="true"/>							
										</a4j:commandButton>					
									</htm:td>
								</htm:tr>
								<htm:tr>
									<htm:td>
										<a4j:commandButton value="Save selected row" 		
											action="#{scoringScaleController.saveCustomRange}" reRender="customRangePanel, scoringScaleOuterPanel" 
											ajaxSingle="true"  immediate="true" 
											onclick="showRichFacesPleaseWait();" oncomplete="hideRichFacesPleaseWait();checkMessage(false);focusCurrentScore();"
											styleClass="rich-list-shuttle-button" style="width:120px;text-align:left;">	
											<a4j:actionparam name="index" value="getSelectedIndex('customRangeRadio')" noEscape="true" assignTo="#{scoringScaleController.numericRangeIndex}"/>							
											<a4j:actionparam name="oldResponseCode" value="getSelectedValue('customRangeRadio')" noEscape="true"/>
											<a4j:actionparam name="newResponseCode" value="document.getElementById('customRangeTxt').value" noEscape="true"/>
										</a4j:commandButton>					
									</htm:td>
								</htm:tr>
								<htm:tr>					
									<htm:td>
										<a4j:commandButton value="Re-Sort by values" 	
											action="#{scoringScaleController.sortCustomRange}" reRender="customRangePanel, scoringScaleOuterPanel" ajaxSingle="true" 
											onclick="showRichFacesPleaseWait();" oncomplete="hideRichFacesPleaseWait();checkMessage(false);focusCurrentScore();"
											styleClass="rich-list-shuttle-button" style="width:120px;text-align:left;">
											<a4j:actionparam name="index" value="0" noEscape="true" assignTo="#{scoringScaleController.numericRangeIndex}"/>
										</a4j:commandButton>					
									</htm:td>					
								</htm:tr>
								<htm:tr>					
									<htm:td>
										<a4j:commandButton value="Close" onclick="Richfaces.hideModalPanel('customRangeWindow')" 
											styleClass="rich-list-shuttle-button"  style="width:120px;text-align:left;"/>					
									</htm:td>					
								</htm:tr>						
							</htm:table>			
						</htm:td>
					</htm:tr>						
				</htm:table>				
			</h:panelGrid>
	</a4j:outputPanel>
</rich:modalPanel>
<script>

	function getSelectedIndex(name) {
		var selectedIndex = -1;
		var selectedObject = document.getElementsByName(name);	
		for (var i = 0; i < selectedObject.length; i++) {
			if (selectedObject[i].checked) {
				selectedIndex = i;
				break;				
			}
		}
		return selectedIndex;
	}

	function getSelectedValue(name) {

		var index = getSelectedIndex(name);
		var value = (index == -1) ? "" : document.getElementsByName(name)[index].value;
		//alert(name + "=" + value);		
		return value;		
	}			

	function focusCurrentScore() {
		document.getElementById('customRangeTxt').focus();
	}
</script>

